unit Main;

// for D6/D7

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, uCalcul, uInterpreter;

type
  TDemoForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    CalcBtn: TButton;
    Vars: TMemo;
    ComboBox1: TComboBox;
    Memo1: TMemo;
    Label3: TLabel;
    Label5: TLabel;
    Memo2: TMemo;
    Button1: TButton;
    Label6: TLabel;
    Button2: TButton;
    CheckBox1: TCheckBox;
    Button3: TButton;
    procedure CalcBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  //  procedure Calcul1Error(sender: TObject; err: String);
  private
    Calcul1:TCalcul;
    Interpreter1:TInterpreter;
    procedure MyVariable(sender:Tobject;const VariableName:string;var VariableValue: variant; var Handled:boolean; Index:integer=0);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DemoForm: TDemoForm;

implementation

{$R *.DFM}

procedure TDemoForm.CalcBtnClick(Sender: TObject);
var s:string[255];
begin
  Calcul1.Formula := ComboBox1.text;
  s:=Calcul1.calc;
  Vars.text:=Calcul1.Variables;
  if Calcul1.CalcError=false then
    ShowMessage('Result='+s)
  else
    ShowMessage(Calcul1.CalcErrorText);
end;

procedure TDemoForm.MyVariable(sender:Tobject;const VariableName:string;var VariableValue: variant; var Handled:boolean; Index:integer=0);
begin
  if UpperCase(VariableName)='MYNAME' then begin
    Handled:=true;
    VariableValue:=Calcul1.QuoteChar+ 'Jan Tungli'+Calcul1.QuoteChar;
  end;
  if UpperCase(VariableName)='MYEMAIL' then begin
    Handled:=true;
    VariableValue:=Calcul1.QuoteChar+'jan.tungli@seznam.cz'+Calcul1.QuoteChar;
  end;
end;

procedure TDemoForm.FormCreate(Sender: TObject);
begin
  Calcul1:=TCalcul.Create;
  Calcul1.OnGetVariable:=MyVariable;
  Interpreter1:=Tinterpreter.Create;
  Interpreter1.Calcul:=Calcul1;
  Calcul1.Variables:=Vars.text; //support only 1 lines variables - use SetValues
end;

procedure TDemoForm.ComboBox1KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then begin key:=#0; calcBtnClick(sender); end;
end;

procedure TDemoForm.Button1Click(Sender: TObject);
begin
  Screen.Cursor:=crHourglass;
  try
    Interpreter1.Prog:=Memo2.text;
    Interpreter1.Execute;
    Vars.text:=Calcul1.Variables;
    if Interpreter1.Error then begin
      ShowMessage(Interpreter1.ErrorText);
      Memo2.SetFocus;
      Memo2.SelStart:=Interpreter1.ErrorPos-1;
    end;
  finally
   Screen.cursor:=crDefault;
   ShowMessage('Ok - end program');
  end;
end;

procedure TDemoForm.Button2Click(Sender: TObject);
begin
 Calcul1.Formula:=Combobox1.text;
 ShowMessage(Calcul1.Formulavariables);
end;

procedure TDemoForm.CheckBox1Click(Sender: TObject);
var i:integer;
    s,t:string;
begin
   if Calcul1.Quotechar='"' then Calcul1.Quotechar:=#39 else Calcul1.Quotechar:='"';
   for i:=0 to Vars.Lines.Count-1 do begin
     s:=Vars.Lines.Strings[i];
     t:=copy(s,1,Pos('=',s));
     s:=trim(copy(s,Pos('=',s)+1,255));
     if length(s)>0 then begin
       if s[1] in ['"',#39] then begin
         s[1]:=Calcul1.Quotechar;
         s[length(s)]:=Calcul1.Quotechar;
       end;
     end;
     Vars.Lines.Strings[i]:=t+s;
   end;
   ComboBox1.Items.text:=StringReplace(ComboBox1.Items.text,'"',Calcul1.Quotechar, [rfReplaceAll]);
   ComboBox1.Items.text:=StringReplace(ComboBox1.Items.text,#39,Calcul1.Quotechar, [rfReplaceAll]);
   ComboBox1.text:=StringReplace(ComboBox1.text,'"',Calcul1.Quotechar, [rfReplaceAll]);
   ComboBox1.text:=StringReplace(ComboBox1.text,#39,Calcul1.Quotechar, [rfReplaceAll]);
   Calcul1.Variables:=Vars.Text;
end;

procedure TDemoForm.Button3Click(Sender: TObject);
var s:string[255];
    i:integer;
    a,b:TDateTime;
begin
  Screen.Cursor:=crHourglass;
  try
  Calcul1.Formula := ComboBox1.text;
  a:=now;
  for i:=1 to 10000 do s:=Calcul1.calc;
  b:=now;
  Vars.Clear;
  Vars.text:=Calcul1.Variables;
  if Calcul1.CalcError=false then
    ShowMessage(Calcul1.Formula+'='+s+#13#10+
    'time:'+FormatDateTime('nn:ss.zzz',b-a))
  else
    ShowMessage(Calcul1.CalcErrorText);
  finally
    Screen.Cursor:=crDefault;
  end;
end;

end.
